// Observer.java
// Source code for observer entity, harassed booking clerk model

package HBCSim;

import java.util.Vector;
import SimObs.*;
import SimExec.*;

/**
* Class to represent an observer noting quote lenghts at regular intervals
*/
public class Observer extends GEntity {
  /** Observations of the length of the personal queue*/
  static Vector persQ;
  /** Observations of the length of the phone queue*/
  static Vector phoneQ;
  /** Number of the latest observation*/
  static int obsNum;
  /** The interval between observations*/
  static int interval;
  /** The next observation*/
  public static Observe nextObservation;

  /**
  * Straightforward constructor.
  * Establishes the queue records, puts the counters to zero and starts with a
  * zero interval between observations.
  */
  Observer(String ID) {
    super(ID);
    persQ = new Vector();
    phoneQ = new Vector();
    obsNum = 0;
    interval = 0;
    nextObservation = new Observe();
  }

  /**
  * Sets in the observation interval
  */
  static public void setInterval(int thisInterval) {
    interval = thisInterval;
  }

  /**
  * Returns with the current observation interval.
  */
  static public int getInterval() {
    return interval;
  }

  /** Implements the Activity interface to create the Observer's only B.
  * The B gets the observer entity, increments the observation counter,
  * notes and saves the suzes of the 2 queues, schedules the next observation
  * and writes to the tracefile.
  */
  class Observe implements Activity {
    public void doThisNow() {
      Observer thisObserver = (Observer)Executive.getCurrEnt();
      obsNum++;
      Integer obs1 = new Integer(PersCust.qIn.size());
      persQ.addElement(obs1);
      Integer obs2 = new Integer(PhoneEnq.qIn.size());
      phoneQ.addElement(obs2);
      Executive.schedule(thisObserver, nextObservation, interval);
      Trace.traceFile.println("Observing queue lengths, interval is " + Observer.interval);
    }
  }
}